--
-- XerionSneu
-- Class for all XerionSneu
--
-- @author  Mev01
-- @date  30/05/10


XerionSneu = {};

function XerionSneu.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function XerionSneu:load(xmlFile)

	self.changeSteer = SpecializationUtil.callSpecializationsFunction("changeSteer");
	self.changeWheel =0;
	
    self.numKotfluegel1 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Kotfluegel1#count"), 0);
    self.Kotfluegel1 = {};
    for i=1, self.numKotfluegel1 do
        local Kotfluegelnamei = string.format("vehicle.Kotfluegel1.Kotfluegel" .. "%d", i);
        self.Kotfluegel1[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, Kotfluegelnamei .. "#index"));
        setVisibility(self.Kotfluegel1[i], true);
    end;

    self.rundumleuchtenAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.rundumleuchten#count"),0);
    self.rundumleuchtenAn = false;
    self.rundumleuchten = {};
    for i=1, self.rundumleuchtenAnz do
        local objname = string.format("vehicle.rundumleuchten.light" .. "%d",i);
        self.rundumleuchten[i] = {};
        self.rundumleuchten[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.rundumleuchten[i].light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#light"));
        self.rundumleuchten[i].source = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#lightsource"));
        self.rundumleuchten[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
        self.rundumleuchten[i].emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
        if not self.rundumleuchten[i].emit and self.rundumleuchten[i].source ~= nil then
           setVisibility(self.rundumleuchten[i].source, false);
        end;
    end;

     local translationNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translation1#index"));
      if translationNode1 ~= nil then
        self.translation1 = {};
        self.translation1.node = translationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation1#minTrans"));
        self.translation1.minTrans = {};
        self.translation1.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation1.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation1.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation1#maxTrans"));
        self.translation1.maxTrans = {};
        self.translation1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation1.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translation1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation1#transTime"), 2)*1000;
        self.translation1.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation1#touchTransLimit"), 10);
    end;

     local translationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translation2#index"));
      if translationNode2 ~= nil then
        self.translation2 = {};
        self.translation2.node = translationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation2#minTrans"));
        self.translation2.minTrans = {};
        self.translation2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation2#maxTrans"));
        self.translation2.maxTrans = {};
        self.translation2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translation2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation2#transTime"), 2)*1000;
        self.translation2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation2#touchTransLimit"), 10);
    end;

        self.extra_lights = {};
        self.extra_lights.rear = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.rear#index"));

    self.rearlightActive = false;
    self.revLimit = 100;
    self.maxRpm1 = self.motor.maxRpm[1];
    self.maxRpm2 = self.motor.maxRpm[2];
	self.maxRpm3 = self.motor.maxRpm[3];
	self.changeWheel = 0; 
    self.Kotfluegel1Active = true;

end;

function XerionSneu:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)  
   if not resetVehicles then
       self.changeWheel = Utils.getNoNil(getXMLFloat(xmlFile, key.."#steer"),0);
end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function XerionSneu:getSaveAttributesAndNodes(nodeIdent)
   local attributes = ' steer="'..tonumber(self.changeWheel)..'"';
   return attributes, nil;
end;

function XerionSneu:keyEvent(unicode, sym, modifier, isDown)
	
      if isDown and sym == Input.KEY_r then
      self.rundumleuchtenAn = not self.rundumleuchtenAn;
      for i=1, self.rundumleuchtenAnz do
        setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
      end;
    end;

      if isDown and sym == Input.KEY_l then
      self.rearlightActive = not self.rearlightActive;
      setVisibility(self.extra_lights.rear, self.rearlightActive);
    end;
	
     if isDown and sym == Input.KEY_0 then
		self.helpPanel = not self.helpPanel;
	end;

     if isDown and sym == Input.KEY_u then
			self.changeWheel = self.changeWheel +1 ; 
	end;

    if sym == Input.KEY_4 then
		self.translation1Max = isDown;
	end;
	if sym == Input.KEY_5 then
		self.translation1Min = isDown;
	end;

    if sym == Input.KEY_7 then
		self.translation2Max = isDown;
	end;
	if sym == Input.KEY_6 then
		self.translation2Min = isDown;
	end;

    if isDown and sym == Input.KEY_z then
		self.Kotfluegel1Active = not self.Kotfluegel1Active;
	end;

end;

function XerionSneu:update(dt)

      if self.Kotfluegel1Active then
		for i=1, self.numKotfluegel1 do
			local Kotfluegel = self.Kotfluegel1[i];
			setVisibility(Kotfluegel, self.Kotfluegel1Active);
		end;
	else
		for i=1, self.numKotfluegel1 do
			local Kotfluegel = self.Kotfluegel1[i];
			setVisibility(Kotfluegel, self.Kotfluegel1Active, false);
		end;
	end;

      if self.isEntered then

        if Input.isKeyPressed(Input.KEY_9) and self.revLimit < 100 then
          self.revLimit = self.revLimit + 1;
        elseif Input.isKeyPressed(Input.KEY_8) and self.revLimit > 10 then
          self.revLimit = self.revLimit - 1;
        end;
        self.motor.maxRpm[1] = string.format("%d",(self.revLimit * self.maxRpm1 / 100));
        self.motor.maxRpm[2] = string.format("%d",(self.revLimit * self.maxRpm2 / 100));
		self.motor.maxRpm[3] = string.format("%d",(self.revLimit * self.maxRpm3 / 100));

        local doTranslate = self.translation1Max or self.translation1Min
	    if self.translation1 ~= nil and doTranslate then
		local x, y, z = getTranslation(self.translation1.node);
		local trans = {x,y,z};
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation1.maxTrans, self.translation1.minTrans, 3, self.translation1.transTime, dt, not self.translation1Max);
		setTranslation(self.translation1.node, unpack(newTrans));
	   end;

        local doTranslate = self.translation2Max or self.translation2Min
	    if self.translation2 ~= nil and doTranslate then
		local x, y, z = getTranslation(self.translation2.node);
		local trans = {x,y,z};
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation2.maxTrans, self.translation2.minTrans, 3, self.translation2.transTime, dt, not self.translation2Max);
		setTranslation(self.translation2.node, unpack(newTrans));
	   end;

	end;
	
		if self.changeWheel == 0  then
         self:changeSteer(25, -25, 60, 25, -25, 60, 0, 0, 0, 0, 0, 0)
      elseif self.changeWheel == 1 then
         self:changeSteer(0, 0, 0, 0, 0, 0, 25, -25, -30, 25, -25, -30)
      elseif self.changeWheel == 2 then
         self:changeSteer(25, -25, 60, 25, -25, 60, 25, -25, -30, 25, -25, -30)
      elseif self.changeWheel == 3 then
         self:changeSteer(25, -25, 60, 25, -25, 60, 25, -25, 60, 25, -25, 60)
      elseif self.changeWheel == 4 then
         self.changeWheel = 0;
        end;
	   if self.rundumleuchtenAn then
          for i=1, self.rundumleuchtenAnz do
            rotate(self.rundumleuchten[i].rotNode, 0, dt*self.rundumleuchten[i].speed, 0);
          end;
        end;
end;

function XerionSneu:onLeave()
        self.Kotfluegel1Active = true;
        self.rearlightActive = false;
        self.rundumleuchtenAn = false;
    for i=1, self.rundumleuchtenAnz do
       setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
    end;
end;

function XerionSneu:draw()

    if self.isEntered then
		if not self.helpPanel then
			renderText(0.8335, 0.17, 0.02, "Taste 0: Info");
            renderText(0.8335, 0.15, 0.02, "Tasten 8/9 "..string.format("%d Prozent", self.revLimit));
		else
			renderText(0.8335, 0.17, 0.02, "Taste 0: Info Abschalten");
            renderText(0.8335, 0.15, 0.02, "Tasten 8/9 "..string.format("%d Prozent", self.revLimit));
		end;
		if self.helpPanel then
            renderText(0.8035, 0.345, 0.02, "L: Arbeitslicht");
			renderText(0.8035, 0.315, 0.02, "Y: Kotflgel ausblenden");
			renderText(0.8035, 0.285, 0.02, "4|5: Kupplung Heben|Senken");
			renderText(0.8035, 0.255, 0.02, "U: Lenkart wechseln");
            renderText(0.8035, 0.225, 0.02, "R: Rundumleuchten");
            renderText(0.8035, 0.195, 0.02, "6|7: Sattelkupplung vor|zurck");
		end;
	end;

end;

function XerionSneu:changeSteer(wheel1min,wheel1max, wheel1speed, wheel2min, wheel2max,wheel2speed, wheel3min, wheel3max,wheel3speed, wheel4min, wheel4max, wheel4speed)
	self.wheels[1].rotMax = Utils.degToRad(wheel1min);
    self.wheels[2].rotMax = Utils.degToRad(wheel2min);
    self.wheels[1].rotMin = Utils.degToRad(wheel1max);
    self.wheels[2].rotMin = Utils.degToRad(wheel2max);   
    self.wheels[3].rotMax = Utils.degToRad(wheel3min);
    self.wheels[4].rotMax = Utils.degToRad(wheel4min);
    self.wheels[3].rotMin = Utils.degToRad(wheel3max);
    self.wheels[4].rotMin = Utils.degToRad(wheel4max);  
    self.wheels[1].rotSpeed = Utils.degToRad(wheel1speed); 
    self.wheels[2].rotSpeed = Utils.degToRad(wheel2speed);
    self.wheels[3].rotSpeed = Utils.degToRad(wheel3speed); 
    self.wheels[4].rotSpeed = Utils.degToRad(wheel4speed); 			
end; 

function XerionSneu:delete()
end;


function XerionSneu:mouseEvent(posX, posY, isDown, isUp, button)
end;



function XerionSneu:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;